#include <stdio.h>
#include <d3dx9.h>

#define MYWNDTITLE		"DX9_Skin"
#define MYWNDCLASS		"CLASS_DX9_Skin"
#define WIDTH			640 			// ʂ̉̃TCY
#define HEIGHT			480 			// ʂ̏c̃TCY
#define SAFE_RELEASE(p)	if (p){p->Release();p=NULL;}
#define SAFE_DELETE(p) 	if (p){delete[]p;p=NULL;}
#define ECT_FILE		".\\pole.ect"	// ECTt@C
#define TEX_FILE		".\\pole.bmp"	// eNX`t@C

struct LVERTEX				// _tH[}bg̒`
{
	D3DXVECTOR3	v;			// W
	float		b;			// uh̏d
	D3DXVECTOR3	n;			// @xNg
	float		tu,tv;		// eNX`W
};
#define FVF_LVERTEX (D3DFVF_XYZB1 | D3DFVF_NORMAL | D3DFVF_TEX1)

typedef struct{
	D3DXVECTOR3	*pv;			// _̍W
	float		*pb;			// uh̏d
	D3DXVECTOR3	*pn;			// _̖@xNg
	float		*ptu,*ptv;		// _̃eNX`W
	int 		(*pf)[4];		// eʂ̒_ԍB_R̂Ƃ pf[][3] = -1B
	int 		t_vtx_ct;		// _
	int 		t_face_ct;		// ʐ
	float		roll;	 		// f̉]pxixj
}MODEL,*LPMODEL;

MODEL	g_m1;		// f̏

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
LPDIRECT3DTEXTURE9		g_pTex = NULL;

HRESULT InitD3D(HWND hWnd);
void	InitGeometry();
void	SetupMatrices();
void	Set_Light();
void	Set_Material();
void	Draw_Main();
void	Draw_Model();
void	Get_Key();
bool	Load_File(char *filename);
void	Cleanup();

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		if(FAILED( InitD3D(hWnd) )){
			MessageBox(hWnd,"D3D9̏Ɏs܂",MYWNDTITLE,0);
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
		if(FAILED( Load_File(ECT_FILE) )){
			MessageBox(hWnd,"t@C̓ǂݍ݂Ɏs܂",MYWNDTITLE,0);
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
		SetTimer(hWnd,1,100,NULL);	// ^C}[ݒ
		break;
		
	case WM_TIMER:
		Get_Key();					// L[͂̎擾
		Draw_Main();				// IuWFNg̕`
		break;
		
	case WM_KEYDOWN:
		switch ( wParam )
		{
		case VK_ESCAPE: 			// [ESC] L[ƏI
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;
		
	case WM_CLOSE:
		KillTimer(hWnd,1);			// ^C}[
		DestroyWindow(hWnd);
		Cleanup();					// Direct3D IuWFNg
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;

	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, WIDTH, HEIGHT,
				NULL,
				NULL,
				hInst,
				NULL);

	if(hWnd == NULL)
		return 0;

	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

// D3D9̏
HRESULT InitD3D(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (!g_pD3D){
		return E_FAIL;
	}
	
	ZeroMemory( &g_d3dpp, sizeof(g_d3dpp) );
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_FLIP;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	
	// D3D9Device 쐬
	if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev ) ) ){
		if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev ) ) ){
			return E_FAIL;
		}
	}
	
	if(FAILED(D3DXCreateTextureFromFile(g_pD3DDev, TEX_FILE, &g_pTex))){
		g_pTex = NULL;
	}
	
	// ݒ̏
	InitGeometry();
	
	return S_OK;
}//InitD3D

// ݒ̏
void InitGeometry()
{
	// JO̐ݒ
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// Zobt@L
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE, TRUE);
	// _tH[}bg̐ݒ
	g_pD3DDev->SetFVF(FVF_LVERTEX);
	// eNX`bsOL
	g_pD3DDev->SetRenderState(D3DRS_WRAP0, D3DWRAPCOORD_0);
	// @̐KL
	g_pD3DDev->SetRenderState(D3DRS_NORMALIZENORMALS, TRUE);
	// WIgufBOL
	g_pD3DDev->SetRenderState(D3DRS_VERTEXBLEND, D3DVBF_1WEIGHTS);
	
	Set_Light();		// Cg̐ݒ
	Set_Material();		// }eA̐ݒ
	SetupMatrices();	// ϊs̐ݒ
	
	// eNX`Kp
	g_pD3DDev->SetTexture(0, g_pTex);
	
}// InitGeometry

// ϊs̐ݒ
void SetupMatrices()
{
	// r[s
	D3DXMATRIX matView;
	D3DXMatrixLookAtLH(&matView,&D3DXVECTOR3(0,0,-2.5f),&D3DXVECTOR3(0,0,0),&D3DXVECTOR3(0,1,0));
	g_pD3DDev->SetTransform(D3DTS_VIEW,&matView);
	// vWFNVs
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj,D3DX_PI/4,(float)WIDTH/HEIGHT,0.01f,10.0f);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION,&matProj);
}// SetupMatrices

// Ɩݒ
void Set_Light()
{
	D3DXVECTOR3 vecDir;
	D3DLIGHT9	light;
	
	ZeroMemory(&light, sizeof(D3DLIGHT9));
	light.Type		= D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r = 1.0f;
	light.Diffuse.g = 1.0f;
	light.Diffuse.b = 1.0f;
	vecDir = D3DXVECTOR3(0.866025f,-0.5f,0.0f);
	D3DXVec3Normalize((D3DXVECTOR3*)&light.Direction, &vecDir);
	
	g_pD3DDev->SetLight(0, &light);
	g_pD3DDev->LightEnable(0, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_LIGHTING, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_AMBIENT, 0x00808080);
}// Set_Light

// }eA̐ݒ
void Set_Material()
{
	D3DMATERIAL9 mtrl;

	ZeroMemory(&mtrl, sizeof(D3DMATERIAL9));
	mtrl.Diffuse.a = mtrl.Ambient.a = 1.0f;
	mtrl.Diffuse.r = mtrl.Ambient.r = 0.8f;
	mtrl.Diffuse.g = mtrl.Ambient.g = 0.8f;
	mtrl.Diffuse.b = mtrl.Ambient.b = 0.8f;
	// }eAKp
	g_pD3DDev->SetMaterial(&mtrl);
}// Set_Material

// `
void Draw_Main()
{	
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
	if( SUCCEEDED( g_pD3DDev->BeginScene() ) )
	{
		Draw_Model();		// f̕`
		
		g_pD3DDev->EndScene();
	}
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
	
	// foCXƂ
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Draw_Main();
	}
}// Draw_Main

// f̕`
void Draw_Model()
{
	int 			i,j,k,idx,f_n;
	static float	roll2 = 0;
	static bool		flag_roll2 = 1;
	static int		face_ct[3] = {0, g_m1.t_face_ct/2, g_m1.t_face_ct};
	LVERTEX			lv[4];
	D3DXMATRIX		matRY,matT[2],matB[2];
	
	D3DXMatrixRotationY(&matRY, g_m1.roll/180*D3DX_PI);
	D3DXMatrixTranslation(&matT[0], 0.04f, 0.04f, 0.0f);
	D3DXMatrixTranslation(&matT[1], -0.04f, -0.04f, 0.0f);
	D3DXMatrixIdentity(&matB[0]);
	D3DXMatrixRotationZ(&matB[1], roll2/180*D3DX_PI);
	matB[0] = matB[0] * matRY;
	matB[1] = matT[0] * matB[1] * matT[1] * matRY;
	g_pD3DDev->SetTransform(D3DTS_WORLDMATRIX(0), &matB[0]);
	
	for(i=0;i<2;i++){
		g_pD3DDev->SetTransform(D3DTS_WORLDMATRIX(1), &matB[i]);
		for(j=face_ct[i];j<face_ct[i+1];j++){
			for(k=0;k<4;k++){
				if(k != 3 || g_m1.pf[j][3] != -1){
					idx = g_m1.pf[j][k];
					lv[k].v  = g_m1.pv [idx];
					lv[k].b  = g_m1.pb [idx];
					lv[k].n  = g_m1.pn [idx];
					lv[k].tu = g_m1.ptu[idx];
					lv[k].tv = g_m1.ptv[idx];
				}						
			}
			f_n = 2;
			if(g_m1.pf[i][3] == -1)
				f_n = 1;
			g_pD3DDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN,f_n,lv,sizeof(LVERTEX));
		}
	}
	if(flag_roll2){
		roll2 -= 5;
	}
	else{
		roll2 += 5;
	}
	if(roll2 >= 90){
		flag_roll2 = 1;
	}
	else if(roll2 < -90){
		flag_roll2 = 0;
	}
}// Draw_Model

// L[
void Get_Key()
{
	if(GetAsyncKeyState(VK_LEFT) & 0x8000){ 		// []L[ꂽƂ
		g_m1.roll -= 5;
		if(g_m1.roll <= 0)
			g_m1.roll += 360;
	}
	else if(GetAsyncKeyState(VK_RIGHT) & 0x8000){	// []L[ꂽƂ
		g_m1.roll += 5;
		if(g_m1.roll >= 360)
			g_m1.roll -= 360;
	}
	
	if(GetAsyncKeyState(VK_UP) & 0x8000){			// []L[ꂽƂ
	}
	else if(GetAsyncKeyState(VK_DOWN) & 0x8000){	// []L[ꂽƂ
	}
}// Get_Key

// ff[^̓ǂݍ
bool Load_File(char *filename)
{
	FILE 	*file1;
	
	char 	ss[256];
	float 	ww[8];
	int		flag = 0;
	int 	vv[4],ct1,ct2 = 0,ct3 = 0;
	
	if((file1=fopen(filename,"r")) == NULL){
		return 0;		
	}
	
	while(!feof(file1)){
		
		fgets(ss,256,file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// IuWFNgŜ̒_W̐
		if(!strcmp(ss,"<total_vertex_count>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</total_vertex_count>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&g_m1.t_vtx_ct);
			g_m1.pv  = new D3DXVECTOR3 [g_m1.t_vtx_ct];
			g_m1.pn  = new D3DXVECTOR3 [g_m1.t_vtx_ct];
			g_m1.pb  = new float       [g_m1.t_vtx_ct];
			g_m1.ptu = new float       [g_m1.t_vtx_ct];
			g_m1.ptv = new float       [g_m1.t_vtx_ct];
			ZeroMemory(g_m1.ptu, g_m1.t_vtx_ct * sizeof(float));
			ZeroMemory(g_m1.ptv, g_m1.t_vtx_ct * sizeof(float));
	
		}
		
		// IuWFNgŜ̖ʂ̐
		else if(!strcmp(ss,"<total_face_count>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</total_face_count>")){
			flag = 0;
		}
		else if(flag == 2){
			sscanf(ss,"%d",&g_m1.t_face_ct);
			g_m1.pf = new int	   [g_m1.t_face_ct][4];
		}
		
		// p[cƂ̒_W
		else if(!strcmp(ss,"<vertices>")){
			flag = 3;
			ct1 = 0;
		}
		else if(!strcmp(ss,"</vertices>")){
			flag = 0;
		}
		else if(flag == 3){
			sscanf(ss,"%f %f %f %f %f %f %f %f",&ww[0],&ww[1],&ww[2],&ww[3],&ww[4],&ww[5],&ww[6],&ww[7]);
			g_m1.pv[ct2].x = ww[0];
			g_m1.pv[ct2].y = ww[1];
			g_m1.pv[ct2].z = ww[2];
			g_m1.pn[ct2].x = ww[3];
			g_m1.pn[ct2].y = ww[4];
			g_m1.pn[ct2].z = ww[5];
			g_m1.ptu[ct2]  = ww[6];
			g_m1.ptv[ct2]  = ww[7];
			
			ct1 ++;
			ct2 ++;
		}
		
		// p[cƂ̖ʂ\钸_W̔ԍ
		else if(!strcmp(ss,"<faces>")){
			flag = 4;
		}
		else if(!strcmp(ss,"</faces>")){
			flag = 0;
		}
		else if(flag == 4){
			sscanf(ss,"%d %d %d %d",&vv[0],&vv[1],&vv[2],&vv[3]);
			g_m1.pf[ct3][0] = vv[0] + ct2 - ct1;
			g_m1.pf[ct3][1] = vv[1] + ct2 - ct1;
			g_m1.pf[ct3][2] = vv[2] + ct2 - ct1;
			if(vv[3] == -1)
				g_m1.pf[ct3][3] = -1;
			else
				g_m1.pf[ct3][3] = vv[3] + ct2 - ct1;
			
			ct3 ++;
		}
	}
	
	fclose(file1);
	
	// _̏d݂ݒ
	float fb;
	for(int i=0;i<g_m1.t_vtx_ct;i++){
		fb = (float) fabs(g_m1.pv[i].y) * 10;
		if(fb > 1){
			fb = 1;
		}
		g_m1.pb[i] = 1 - fb;
	}
	
	return 1;
}// Load_File

// IuWFNg̉
void Cleanup()
{
	g_pD3DDev->SetTexture(0, NULL);
	// eNX`
	SAFE_RELEASE(g_pTex);
	//̈
	SAFE_DELETE(g_m1.pv);
	SAFE_DELETE(g_m1.pb);
	SAFE_DELETE(g_m1.pn);
	SAFE_DELETE(g_m1.ptu);
	SAFE_DELETE(g_m1.ptv);
	SAFE_DELETE(g_m1.pf);
	// Direct3D IuWFNg
	SAFE_RELEASE(g_pD3DDev);
	SAFE_RELEASE(g_pD3D);
}// Cleanup
